﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WinFormsHostApp
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }

        // For the love of interoprability of WPF
        // http://social.msdn.microsoft.com/Forums/vstudio/en-US/86a618ff-5df7-4053-b381-2371dfd260d0/winformwpf-interoperation-question
        // http://drwpf.com/blog/2007/10/05/managing-application-resources-when-wpf-is-hosted/
        // DRAT!
        // http://stackoverflow.com/questions/8299664/style-targettype-causes-xamlparseexception-when-not-attached-to-debugger
        public static void EnsureApplicationResources()
        {
            if (System.Windows.Application.Current == null)
            {
                // create the Application object
                System.Windows.Application app = new System.Windows.Application();
                app.ShutdownMode = System.Windows.ShutdownMode.OnExplicitShutdown;

                // merge in application resources
                System.Windows.Application.Current.Resources.MergedDictionaries.Add(
                    System.Windows.Application.LoadComponent(
                        new Uri("/WinFormsHostApp;component/UI/WPF/Infragistics/generic.shared.xaml", UriKind.RelativeOrAbsolute)) as System.Windows.ResourceDictionary);

                // merge in application resources
                System.Windows.Application.Current.Resources.MergedDictionaries.Add(
                    System.Windows.Application.LoadComponent(
                        new Uri("/WinFormsHostApp;component/UI/WPF/Infragistics/XamGridCustomizations.xaml", UriKind.RelativeOrAbsolute)) as System.Windows.ResourceDictionary);

                System.Windows.Application.Current.DispatcherUnhandledException += WPFUnHandledExceptionHandler;
            }
        }

        private static void WPFUnHandledExceptionHandler(object sender, System.Windows.Threading.DispatcherUnhandledExceptionEventArgs e)
        {
            // Util.LogError(e);
        }
    }
}
